/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "clear" set of functions */

#include <curses.h>
#include "fcursdef.h"

/*************************************************************/

INT4 werase_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return werase( win );
}

/**************************************************************/

INT4 erase_()
{
	return erase();
}

/*************************************************************/

INT4 wclear_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return wclear( win );
}

/**************************************************************/

INT4 clear_()
{
	return clear();
}

/*************************************************************/

INT4 wclrtobot_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return wclrtobot( win );
}

/**************************************************************/

INT4 clrtobot_()
{
	return clrtobot();
}

/*************************************************************/

INT4 wclrtoeol_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return wclrtoeol( win );
}

/**************************************************************/

INT4 clrtoeol_()
{
	return clrtoeol();
}
