/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "delch" set of functions */

#include <curses.h>
#include "fcursdef.h"

/*************************************************************/

INT4 wdelch_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return wdelch( win );
}

/**************************************************************/

INT4 delch_()
{
	return delch();
}

/*************************************************************/

INT4 mvwdelch_( wnum, y, x )
INT4 *wnum;
INT4 *y;
INT4 *x;
{
	int tmpy = *y;
	int tmpx = *x;

	WINDOW *win;

	win = (WINDOW *) *wnum;

	return mvwdelch( win, tmpy, tmpx );
}

/*************************************************************/

INT4 mvdelch_( y, x )
INT4 *y;
INT4 *x;
{
	return mvwdelch_( (INT4 *) &stdscr, y, x );
}
