/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "deletln" set of functions */

#include <curses.h>
#include "fcursdef.h"

/*************************************************************/

INT4 wdeleteln_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return wdeleteln( win );
}

/**************************************************************/

INT4 deleteln_()
{
	return deleteln();
}

/*************************************************************/

INT4 winsdelln_( wnum, n )
INT4 *wnum;
INT4 *n;
{
	int ntmp = *n;

	WINDOW *win;

	win = (WINDOW *) *wnum;

	return winsdelln( win, ntmp );
}

/*************************************************************/

INT4 insdelln_( n )
INT4 *n;
{
	int ntmp = *n;

	return insdelln( ntmp );
}

/*************************************************************/

INT4 winsertln_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return winsertln( win );
}

/**************************************************************/

INT4 insertln_()
{
	return insertln();
}
