/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "echochar" set of curses functions */

#include <curses.h>
#include "fcursdef.h"

/*******************************************************************/

INT4 wechochar_( wnum, ch )	/* the fortran routine is passing the */
INT4 *wnum;			/* integer representation of the character */
INT4 *ch;
{
	chtype tmpch = *ch;

	WINDOW *win;

	win = (WINDOW *) *wnum;

	return wechochar( win, tmpch );
}

/**************************************************************/

/* as in C, this just calls 'wechochar' with "stdscr" as the window */

INT4 echochar_( ch )
INT4 *ch;
{
	return wechochar_( (INT4 *) &stdscr, ch );
}
