/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* routines to initialize curses constants on the fortran side */

#include <curses.h>
#include "fcursdef.h"

INT4 crsprmval[151];

/*******************************************************************/

INT4 setcursparm_()
{
#if defined(DOS) || defined(OS2)
	crsprmval[ 1] = 0;
#else
	crsprmval[ 1] = curs_errno;
#endif
	crsprmval[ 2] = LINES;
	crsprmval[ 3] = COLS;
	crsprmval[ 4] = COLOR_BLACK;
	crsprmval[ 5] = COLOR_RED;
	crsprmval[ 6] = COLOR_GREEN;
	crsprmval[ 7] = COLOR_YELLOW;
	crsprmval[ 8] = COLOR_BLUE;
	crsprmval[ 9] = COLOR_MAGENTA;
	crsprmval[10] = COLOR_CYAN;
	crsprmval[11] = COLOR_WHITE;
#if defined(DOS) || defined(OS2)
	crsprmval[12] = 8;
#else
	crsprmval[12] = TABSIZE;
#endif
	crsprmval[13] = ERR;
	crsprmval[14] = OK;
	crsprmval[15] = NULL;
	crsprmval[16] = A_STANDOUT;
	crsprmval[17] = A_UNDERLINE;
	crsprmval[18] = A_REVERSE;
	crsprmval[19] = A_BLINK;
	crsprmval[20] = A_DIM;
	crsprmval[21] = A_BOLD;
#if defined(DOS) || defined(OS2)
	crsprmval[22] = A_NORMAL;
#else
	crsprmval[22] = A_INVIS;
#endif
	crsprmval[23] = A_PROTECT;
	crsprmval[24] = A_NORMAL;
	crsprmval[25] = A_ATTRIBUTES;
	crsprmval[26] = A_CHARTEXT;
	crsprmval[27] = A_COLOR;
	crsprmval[28] = '\n';
	crsprmval[29] = '\r';
	crsprmval[30] = '\f';
	crsprmval[31] = '\t';
	crsprmval[32] = KEY_MIN;
	crsprmval[33] = KEY_BREAK;
	crsprmval[34] = KEY_DOWN;
	crsprmval[35] = KEY_UP;
	crsprmval[36] = KEY_LEFT;
	crsprmval[37] = KEY_RIGHT;
	crsprmval[38] = KEY_HOME;
	crsprmval[39] = '\b';
	crsprmval[40] = KEY_F0;
	crsprmval[41] = KEY_DL;
	crsprmval[42] = KEY_IL;
	crsprmval[43] = KEY_DC;
	crsprmval[44] = KEY_IC;
	crsprmval[45] = KEY_EIC;
	crsprmval[46] = KEY_CLEAR;
	crsprmval[47] = KEY_EOS;
	crsprmval[48] = KEY_EOL;
	crsprmval[49] = KEY_SF;
	crsprmval[50] = KEY_SR;
	crsprmval[51] = KEY_NPAGE;
	crsprmval[52] = KEY_PPAGE;
	crsprmval[53] = KEY_STAB;
	crsprmval[54] = KEY_CTAB;
	crsprmval[55] = KEY_CATAB;
	crsprmval[56] = KEY_ENTER;
	crsprmval[57] = KEY_SRESET;
	crsprmval[58] = KEY_RESET;
	crsprmval[59] = KEY_PRINT;
	crsprmval[60] = KEY_LL;
	crsprmval[61] = KEY_A1;
	crsprmval[62] = KEY_A3;
	crsprmval[63] = KEY_B2;
	crsprmval[64] = KEY_C1;
	crsprmval[65] = KEY_C3;
	crsprmval[66] = KEY_BTAB;
	crsprmval[67] = KEY_BEG;
	crsprmval[68] = KEY_CANCEL;
	crsprmval[69] = KEY_CLOSE;
	crsprmval[70] = KEY_COMMAND;
	crsprmval[71] = KEY_COPY;
	crsprmval[72] = KEY_CREATE;
	crsprmval[73] = KEY_END;
	crsprmval[74] = KEY_EXIT;
	crsprmval[75] = KEY_FIND;
	crsprmval[76] = KEY_HELP;
	crsprmval[77] = KEY_MARK;
	crsprmval[78] = KEY_MESSAGE;
	crsprmval[79] = KEY_MOVE;
	crsprmval[80] = KEY_NEXT;
	crsprmval[81] = KEY_OPEN;
	crsprmval[82] = KEY_OPTIONS;
	crsprmval[83] = KEY_PREVIOUS;
	crsprmval[84] = KEY_REDO;
	crsprmval[85] = KEY_REFERENCE;
	crsprmval[86] = KEY_REFRESH;
	crsprmval[87] = KEY_REPLACE;
	crsprmval[88] = KEY_RESTART;
	crsprmval[89] = KEY_RESUME;
	crsprmval[90] = KEY_SAVE;
	crsprmval[91] = KEY_SBEG;
	crsprmval[92] = KEY_SCANCEL;
	crsprmval[93] = KEY_SCOMMAND;
	crsprmval[94] = KEY_SCOPY;
	crsprmval[95] = KEY_SCREATE;
	crsprmval[96] = KEY_SDC;
	crsprmval[97] = KEY_SDL;
	crsprmval[98] = KEY_SELECT;
	crsprmval[99] = KEY_SEND;
	crsprmval[100] = KEY_SEOL;
	crsprmval[101] = KEY_SEXIT;
	crsprmval[102] = KEY_SFIND;
	crsprmval[103] = KEY_SHELP;
	crsprmval[104] = KEY_SHOME;
	crsprmval[105] = KEY_SIC;
	crsprmval[106] = KEY_SLEFT;
	crsprmval[107] = KEY_SMESSAGE;
	crsprmval[108] = KEY_SMOVE;
	crsprmval[109] = KEY_SNEXT;
	crsprmval[110] = KEY_SOPTIONS;
	crsprmval[111] = KEY_SPREVIOUS;
	crsprmval[112] = KEY_SPRINT;
	crsprmval[113] = KEY_SREDO;
	crsprmval[114] = KEY_SREPLACE;
	crsprmval[115] = KEY_SRIGHT;
	crsprmval[116] = KEY_SRSUME;
	crsprmval[117] = KEY_SSAVE;
	crsprmval[118] = KEY_SSUSPEND;
	crsprmval[119] = KEY_SUNDO;
	crsprmval[120] = KEY_SUSPEND;
	crsprmval[121] = KEY_UNDO;
	crsprmval[122] = NULL;
	crsprmval[123] = KEY_MAX;
	crsprmval[124] = (INT4) curscr;

	crsprmval[125] = ACS_ULCORNER;
	crsprmval[126] = ACS_LLCORNER;
	crsprmval[127] = ACS_URCORNER;
	crsprmval[128] = ACS_LRCORNER;
	crsprmval[129] = ACS_RTEE;
	crsprmval[130] = ACS_LTEE;
	crsprmval[131] = ACS_BTEE;
	crsprmval[132] = ACS_TTEE;
	crsprmval[133] = ACS_HLINE;
	crsprmval[134] = ACS_VLINE;
	crsprmval[135] = ACS_PLUS;
	crsprmval[136] = ACS_S1;
	crsprmval[137] = ACS_S9;
	crsprmval[138] = ACS_DIAMOND;
	crsprmval[139] = ACS_CKBOARD;
	crsprmval[140] = ACS_DEGREE;
	crsprmval[141] = ACS_PLMINUS;
	crsprmval[142] = ACS_BULLET;

	crsprmval[143] = ACS_LARROW;
	crsprmval[144] = ACS_RARROW;
	crsprmval[145] = ACS_DARROW;
	crsprmval[146] = ACS_UARROW;
	crsprmval[147] = ACS_BOARD;
	crsprmval[148] = ACS_LANTERN;
	crsprmval[149] = ACS_BLOCK;

	crsprmval[150] = A_ALTCHARSET;

	return OK;
}

/*******************************************************************/

INT4 cursparm_( ival )
INT4 *ival;
{
	return crsprmval[*ival];
}

/*******************************************************************/

/* initialize the COLORS variable on the fortran side */
/*  (must be called after start_color() */

INT4 colorlim_()
{
	return COLORS;
}

/*******************************************************************/

/* initialize the COLOR_PAIRS variable on the fortran side */
/*  (must be called after start_color() */

INT4 colorpset_()
{
	return COLOR_PAIRS;
}

/*****************************************************************/

/* a generic bitwize OR routine for the FORTRAN side */

INT4 b_or_( n1, n2)
INT4 *n1;
INT4 *n2;
{
	return ( *n1 | *n2 );
}

/*****************************************************************/

/* a generic bitwize AND routine for the FORTRAN side */

INT4 b_and_( n1, n2)
INT4 *n1;
INT4 *n2;
{
	return ( *n1 & *n2 );
}

/*****************************************************************/

/* a generic bitwize SHIFT routine for the FORTRAN side */

INT4 b_shft_( n1, n2)
INT4 *n1;
INT4 *n2;
{
	INT4 tmpshift;
	tmpshift = ( *n2 < 0 ) ? -*n2 : *n2;

	if( *n2 > 0 )
		return ( *n1 << tmpshift );
	else if( *n2 < 0 )
		return ( *n1 >> tmpshift );
	else
		return *n1;
}

/*****************************************************************/

#ifdef	KEY_F
#undef	KEY_F
#endif

INT4 key_f_( n )
INT4 *n;
{
	return ( KEY_F0 + *n );
}

/**************************************************************/

/* raw string output that doesn't go through curses */

INT4 trawprint_( str, len )
char *str;
INT4 *len;
{
	int i;
	char tmpstr[256];

	for ( i = 0; i<*len; i++ )
		tmpstr[i] = str[i];
	tmpstr[*len] = '\0';

	return printf("%s", tmpstr );
}
