/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "util" set of functions */

#include <curses.h>
#include "fcursdef.h"

#include <string.h>

INT4 napms_();

/*************************************************************/

INT4 unctrltmp_( str, len, c )	/* used in conjunction with fortran */
char *str;				/* unctrl routine */
INT4 *len;
INT4 *c;
{
	chtype ctmp = *c;
	int end, i;
	char tmpstr[40];

	if( strcpy(tmpstr,unctrl(ctmp)) == NULL )
		return ERR;
	end = strlen(tmpstr);

	end = (end<*len?end:*len);

	for (i = 0; i < *len; i++) {
		if( i < end )
			str[i] = tmpstr[i];
		else
			str[i] = ' ';
	}

	return OK;
	
}

/*************************************************************/

INT4 keynametmp_( str, len, c ) /* used in conjunction with fortran */
char *str;				/* keyname routine */
INT4 *len;
INT4 *c;
{
	int ctmp = *c;
	int end, i;
	char tmpstr[40];

	if( strcpy(tmpstr,keyname(ctmp)) == NULL )
		return ERR;
	end = strlen(tmpstr);

	end = (end<*len?end:*len);

	for (i = 0; i < *len; i++) {
		if( i < end )
			str[i] = tmpstr[i];
		else
			str[i] = ' ';
	}

	return OK;
	
}

/*************************************************************/

#if !defined(DOS) && !defined(OS2)
INT4 filter_()
{
	return filter();
}
#endif

/*************************************************************/

/* 3.2 unix doesn't have this use_env, so don't include for now */
/**************************************************
   not supporting putwin, getwin
***************************************************/

/*************************************************************/

INT4 flushinp_()
{
	return flushinp();
}

/*************************************************************/

/* delay output for a certain number of milliseconds */

INT4 delay_output_( ms )
INT4 *ms;
{
/*	int mstmp = *ms;*/

/*	return delay_output( mstmp );*/
/*	return napms( mstmp );*/

/* delay output rarely is implemented correctly, call the F-curses stub */
/* napms_ which has some alternatives if napms() itself isn't working */
/* properly */

	return napms_( ms );

}
