
***********************************************************************

	subroutine getval( fieldval )

*	read the contents of the main display field and the exponent
*	field of the calculator and convert the strings into an equivalent
*	double precision number
	
	implicit none

	include '../../curses.fh'

	include 'calclate.fh'
	include 'calcstat.fh'

	character tmpstr*25, stripcommas*25
	integer*4 firstchr, retval, is, ic, ie, mfield, efield

	real*8  fieldval
	integer*4 exponval, ch2double

	if( compentry ) then
	  mfield = mainfield_i
	  efield = expfield_i
	else
	  mfield = mainfield
	  efield = expfield
	endif
	fieldval = 0.

	call loadfield( mfield, tmpstr )
	tmpstr = stripcommas( tmpstr )
	if( ch2double( tmpstr, fieldval ) .eq. -1) go to 999
	call loadfield( efield, tmpstr )
	ic = index(tmpstr,'e')
	if(ic .gt. 0) then
	  read(tmpstr(ic+2:ic+4), '(i3)', err=1099 ) exponval
	else
	  exponval = 0
	endif

	fieldval = fieldval * 10.0D0**exponval

     	return

  999   fieldval = 0.
  	return

 1099	retval = mvaddstr(0,0, 'ouch 2')
  	retval = refresh()
  	return

	end
