
***************************************************************

* a new key on the calculator has been navigated to, give it a special
* attribute and return the standard attribute to the key that was left.

	integer function lightpad( hotkey, oldkey, newkey )
	
	implicit none
	
	include '../../curses.fh'

*	window values for the new and old windows

	integer hotkey, oldkey, newkey, retval

	integer  keyattr, hotattr
	common /attrcom/ keyattr, hotattr

	integer keywin(45)
	common /keypoint/ keywin

	lightpad = ERR

	oldkey = hotkey
	hotkey = newkey

	if(wbkgd( keywin(oldkey), keyattr ) .eq. ERR) return
	if(wnoutrefresh( keywin(oldkey) ) .eq. ERR) return
	if(wbkgd( keywin(hotkey), hotattr ) .eq. ERR) return
	if(wnoutrefresh( keywin(hotkey) ) .eq. ERR) return
	if(move(0,0) .eq. ERR) return
	if(refresh() .eq. ERR) return

	lightpad = OK
	return
	end
