* wrs
* calculations for the different functions chosen from the math functions menu
*  (split out of "curscalc.f" to reduce the size of that source file)

	subroutine mathfunc(ichosen)

	implicit none

	integer ichosen

	include 'calclate.fh'
	include 'calcstat.fh'
	include 'register.fh'

	integer displayval, imx, i, retval

	complex*16 cmpval, cmpval2
	real*8     splitcmp(2)
	equivalence ( cmpval, splitcmp(1) )

	lastx   = screenval
	lastx_i = screenval_i
	cmpval = dcmplx( screenval, screenval_i )

	if( ichosen .eq. 1 ) then

* 1/x
		if( splitcmp(1) .eq. 0. .and. splitcmp(2) .eq. 0. ) then
			cmpval = 1.0d150
		else
			cmpval = 1.0 / cmpval
		endif

	elseif( ichosen .eq. 2 ) then

*  x^2
		cmpval = cmpval*cmpval

	elseif( ichosen .eq. 3 ) then

*  sqrt(x)
		if( (.not. compmode) .and. splitcmp(1) .lt. 0. ) then
			cmpval = 1.0d150
		else
			cmpval = sqrt( cmpval )
		endif

	elseif( ichosen .eq. 4 ) then

* sin(x)
		if( radflag .eq. 1 ) then
		  cmpval = cmpval * asin(1.0D0)/90.
		elseif( radflag .eq. 3 ) then
		  cmpval = cmpval * asin(1.0D0)/100.
		endif
		cmpval = sin(cmpval)

	elseif( ichosen .eq. 5 ) then
*  cos(x)
		if( radflag .eq. 1 ) then
		  cmpval = cmpval * asin(1.0D0)/90.
		elseif( radflag .eq. 3 ) then
		  cmpval = cmpval * asin(1.0D0)/100.
		endif
		cmpval = cos(cmpval)

	elseif( ichosen .eq. 6 ) then

* tan(x)
		if( radflag .eq. 1 ) then
		  cmpval = cmpval * asin(1.0D0)/90.
		elseif( radflag .eq. 3 ) then
		  cmpval = cmpval * asin(1.0D0)/100.
		endif
		cmpval2 = cmpval
		cmpval = cos(cmpval)
		if( splitcmp(1) .eq. 0. .and. splitcmp(2) .eq. 0. ) then
			cmpval = 1.0d150
		else
			cmpval = sin(cmpval2)/cos(cmpval2)
		endif

	elseif( ichosen .eq. 7 ) then

* arcsin(x)
		if( compmode ) then
		  cmpval = 1.0d150
		  errstate = 2
		elseif( abs(splitcmp(1)) .gt. 1.0 ) then
		  cmpval = 1.0d150
		else
		  cmpval = asin(splitcmp(1))
		  if( radflag .eq. 1 ) then
		    cmpval = cmpval * 90.0/asin(1.0D0)
		  elseif( radflag .eq. 3 ) then
		    cmpval = cmpval * 100.0/asin(1.0D0)
		  endif
		endif

	elseif( ichosen .eq. 8 ) then

* arccos(x)
		if( compmode ) then
		  cmpval = 1.0d150
		  errstate = 2
		elseif( abs(splitcmp(1)) .gt. 1.0 ) then
		  cmpval = 1.0d150
		else
		  cmpval = acos(splitcmp(1))
		  if( radflag .eq. 1 ) then
		    cmpval = cmpval * 90.0/asin(1.0D0)
		  elseif( radflag .eq. 3 ) then
		    cmpval = cmpval * 100.0/asin(1.0D0)
		  endif
		endif

	elseif( ichosen .eq. 9 ) then

* arctan(x)
		if( compmode ) then
		  cmpval = 1.0d150
		  errstate = 2
		else
		  cmpval = atan(splitcmp(1))
		  if( radflag .eq. 1 ) then
		    cmpval = cmpval * 90.0/asin(1.0D0)
		  elseif( radflag .eq. 3 ) then
		    cmpval = cmpval * 100.0/asin(1.0D0)
		  endif
		endif

	elseif( ichosen .eq. 10 ) then

* e^x
		if( splitcmp(1) .gt. 235 ) then
		  cmpval = 1.0d150
		else
		  cmpval = exp( cmpval )
		endif

	elseif( ichosen .eq. 11 ) then

*	ln(x)
		if( splitcmp(1) .le. 0. ) then
		  if( splitcmp(2) .eq. 0. ) then
		    cmpval = 1.0d150
		  else
		    cmpval = log( cmpval )
		  endif
		else
		  cmpval = log( cmpval )
		endif

	elseif( ichosen .eq. 12 ) then

*	log10(x)
		if( compmode ) then
		  cmpval = 1.0d150
		  errstate = 2
		else
		  if( splitcmp(1) .le. 0. ) then
		    cmpval = 1.0d150
		  else
		    cmpval = log10( splitcmp(1) )
		  endif
		endif

	elseif( ichosen .eq. 13 ) then

* x!
		tmpval = screenval
		if( tmpval .lt. 0. .or. tmpval .gt. 69 ) then
		  tmpval = 1.0D150
		elseif( tmpval .ne. nint(tmpval) ) then
		  tmpval = 1.0D150
		else
		  imx = nint(tmpval)
		  tmpval = 1.0
		  do i = 1, imx
		     tmpval = tmpval * i
		  end do
		endif
		cmpval = dcmplx( tmpval, screenval_i )

	elseif( ichosen .eq. 14 ) then

* hypsin(x)
		if( splitcmp(1) .gt. 235 ) then
		  cmpval = 1.0D150
		else
		  cmpval = (exp(cmpval) - exp(-cmpval))/2.0d0
		endif

	elseif( ichosen .eq. 15 ) then

* hypcos(x)
		if( splitcmp(1) .gt. 235 ) then
		  cmpval = 1.0D150
		else
		  cmpval = (exp(cmpval) + exp(-cmpval))/2.0d0
		endif

	elseif( ichosen .eq. 16 ) then

* hyptan(x)
		if( splitcmp(1) .gt. 235 ) then
		  cmpval = 1.0D150
		else
		  cmpval = (exp(cmpval) - exp(-cmpval)) /
&				(exp(cmpval) + exp(-cmpval))
		endif

	elseif( ichosen .eq. 17 ) then

*	fill all stack
*	registers with X (this needs to be last item in function menu)

		splitcmp(1) = screenval
		splitcmp(2) = screenval_i
		do i = 1, MAXREGS
			regval(i,1) = screenval
			regval(i,2) = screenval_i
		end do

	endif

	retval = displayval( splitcmp(1), splitcmp(2) )
	if( rpnmode ) then
		if( retval .eq. -1 ) then
			action = .false.
		else
		 	action = .true.
		endif
	else
	  	action = .false.
	endif
	numinit = .true.

	return
	end
