
***********************************************************************

* print a message on line one of the screen (in stdscr)

	integer function message(str)

	implicit none

	include '../../curses.fh'

	character*(*) str
	integer retval, cpair, setpair, lastchr

	retval = move(0,0)

*	clear to the end of the line

	retval = clrtoeol()

*	display the message in the terminals best highlighting mode

	if( has_colors() ) then
		cpair = setpair( COLOR_BLACK, COLOR_WHITE )
		retval = attron( cpair )
		retval = addstr( ' ' )
		retval = mvaddstr( 0, 1, str(:lastchr(str)) )
		retval = attroff( cpair )
		call freepair( cpair )
	else
		retval = standout()
		retval = addstr( ' ' )
		retval = mvaddstr( 0, 1, str(:lastchr(str)) )
		retval = standend()
	endif

	retval = wnoutrefresh(stdscr)

	return
	end
