* WRS (11/93)
* scatter -- take the contents of the F-curses screen and randomly rearange
*		them.

	subroutine scatter()

	implicit none

	include '../../curses.fh'

*	make the changes in a new window

	integer scatterwin

	integer count, ax, ay, bx, by, ach, bch, i

*	random number function ( returns a value from 0.0 to 1.0 )

	real*4 random

	integer*4  seed
	data seed /51345/

	scatterwin = newwin(0,0,0,0)
	call scrollok( scatterwin, .FALSE. )
	call clearok( scatterwin, .FALSE. )

	call overwrite( curscr, scatterwin )

	count = LINES*COLS

	do i = 1, count

*		randomly pick coordinates for two characters, then swap them

		ay = max(0, min( nint(random(seed)*LINES), LINES-1) )
		ax = max(0, min( nint(random(seed)*COLS), COLS-1) )
		by = max(0, min( nint(random(seed)*LINES), LINES-1) )
		bx = max(0, min( nint(random(seed)*COLS), COLS-1) )

		ach = mvwinch( curscr, ay, ax )
		bch = mvwinch( curscr, by, bx )

		call mvwaddch( scatterwin, ay, ax, bch )
		call mvwaddch( scatterwin, by, bx, ach )
		call wrefresh( scatterwin )

	end do

	call delwin( scatterwin )
	call untouchwin( curscr )
	call clearok( curscr, .FALSE. )

	return
	end
