/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "getyx" set of macros */

/* since these are macros, there isn't any need to ensure that y and x */
/* are the correct integer types being passed */

#include <curses.h>
#include "fcursdef.h"

/*************************************************************/

INT4 getyx_( wnum, y, x )
INT4 *wnum;
INT4 *y;
INT4 *x;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	getyx( win, *y, *x );
	return OK;
}

/*************************************************************/

INT4 getparyx_( wnum, y, x )
INT4 *wnum;
INT4 *y;
INT4 *x;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	getparyx( win, *y, *x );
	return OK;
}

/*************************************************************/

INT4 getbegyx_( wnum, y, x )
INT4 *wnum;
INT4 *y;
INT4 *x;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	getbegyx( win, *y, *x );
	return OK;
}

/*************************************************************/

INT4 getmaxyx_( wnum, y, x )
INT4 *wnum;
INT4 *y;
INT4 *x;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	getmaxyx( win, *y, *x );
	return OK;
}
