/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "insch" set of functions */

#include <curses.h>
#include "fcursdef.h"

/*************************************************************/

INT4 winsch_( wnum, ch )	/* the fortran routine is passing the */
INT4 *wnum;			/* integer representation of the character */
INT4 *ch;
{
	chtype tmpch = *ch;

	WINDOW *win;

	win = (WINDOW *) *wnum;

	return winsch( win, tmpch );
}

/**************************************************************/

INT4 insch_( ch )
INT4 *ch;
{
	chtype tmpch = *ch;

	return insch( tmpch );
}

/*************************************************************/

INT4 mvwinsch_( wnum, y, x, ch )
INT4 *wnum;
INT4 *y;
INT4 *x;
INT4 *ch;
{
	int tmpy = *y;
	int tmpx = *x;
	chtype tmpch = *ch;

	WINDOW *win;

	win = (WINDOW *) *wnum;

	return mvwinsch( win, tmpy, tmpx, tmpch );
}

/*************************************************************/

INT4 mvinsch_( y, x, ch )
INT4 *y;
INT4 *x;
INT4 *ch;
{
	return mvwinsch_( (INT4 *) &stdscr, y, x, ch );
}
