/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "wmove" and "move" functions */

#include <curses.h>
#include "fcursdef.h"

/*********************************************************************/

INT4 wmove_( wnum, y , x )
INT4 *wnum;
INT4 *y;
INT4 *x;
{
	WINDOW *win;
	int xt, yt;
	
	yt = *y;	/* make sure to pass the correct */
	xt = *x; 	/* types to the curses routines */

	win = (WINDOW *) *wnum;

	return wmove(win, yt, xt);
}

/**************************************************************/

/* call 'wmove' with "stdscr" as the window */

INT4 move_(y, x)
INT4 *y;
INT4 *x;
{
	return wmove_( (INT4 *) &stdscr, y, x );
}
