# wrs (9/10/93)
#  this program finds C routine names ending in "_(" and makes any other
#  ending separator depending on the variable "dashes" and if the flag
#  "upper" is set to true, then it also makes the names upper case.
#  The resulting output file name is modified accordingly as well
#

BEGIN {
	tr["a"] = "A"
	tr["b"] = "B"
	tr["c"] = "C"
	tr["d"] = "D"
	tr["e"] = "E"
	tr["f"] = "F"
	tr["g"] = "G"
	tr["h"] = "H"
	tr["i"] = "I"
	tr["j"] = "J"
	tr["k"] = "K"
	tr["l"] = "L"
	tr["m"] = "M"
	tr["n"] = "N"
	tr["o"] = "O"
	tr["p"] = "P"
	tr["q"] = "Q"
	tr["r"] = "R"
	tr["s"] = "S"
	tr["t"] = "T"
	tr["u"] = "U"
	tr["v"] = "V"
	tr["w"] = "W"
	tr["x"] = "X"
	tr["y"] = "Y"
	tr["z"] = "Z"
}

{
	if( ofilename != FILENAME ) {

		if( outfile != "" )
			close( outfile )
		ofilename = FILENAME

		infile = FILENAME
		if( (ic=index(FILENAME,".c")) == 0 )
			exit
		tempfile = predash substr(FILENAME,1,ic-1) dashes
		if( upper == "TRUE" ) {
			tempfile = upcase(tempfile)
		}
		outfile = "temp/" tempfile ".c"
		print " " > outfile

		print "Converting " FILENAME " to " outfile

	}

	if( (ic=index($0,"_(")) != 0 ) {
	  if( (jnk=index($0,"/*")) == 0 || jnk > ic ) {

		ib=1
		for( i=ic; i>0; i--) {
			if( substr($0,i,1) == " " || substr($0,i,1) == "(" || \
				substr($0,i,1) == "\t" ){
				ib = i+1
				break
			}
		}
		instring = substr($0,ib,ic-ib)
		tempstring = predash instring dashes
		outstring = tempstring
		if( upper == "TRUE" ) {
			outstring = upcase(tempstring)
		}
		print substr($0,1,ib-1) outstring substr($0,ic+1) >> outfile
	  }
	  else
		print >> outfile
	}
	else
		print >> outfile
}

################################

function upcase ( temp ) {

#	"echo " temp "| tr \"[a-z]\" \"[A-Z]\" " | getline outstring
#	close( "echo " temp "| tr \"[a-z]\" \"[A-Z]\" " )

	outstring = ""
	len = length(temp)
	for( i=1; i<=len; i++ ) {
		ch = substr(temp,i,1)
		if( ch >= "a" && ch <= "z" ) {
			ch = tr[ch]
		}
		outstring = outstring ch
	}

	return outstring
}
