/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "refresh" set of functions */

#include <curses.h>
#include "fcursdef.h"

/*************************************************************/

INT4 wrefresh_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return wrefresh( win );
}

/**************************************************************/

INT4 refresh_()
{
	return refresh();
}

/*************************************************************/

INT4 wnoutrefresh_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return wnoutrefresh( win );
}

/**************************************************************/

INT4 doupdate_()
{
	return doupdate();
}

/*************************************************************/

INT4 redrawwin_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return redrawwin( win );
}

/*************************************************************/

INT4 wredrawln_( wnum, beg_line, num_lines )
INT4 *wnum;
INT4 *beg_line;
INT4 *num_lines;
{
	int tbeg = *beg_line;
	int tnum = *num_lines;

	WINDOW *win;

	win = (WINDOW *) *wnum;

	return wredrawln( win, tbeg, tnum );
}
