*
*  call a routine which allows a user to pick from a range of colors and
*  choose the attribute they want.
*
	implicit none

	include '../../curses.fh'
	include 'colorset.fh'
	
	integer*4	pickcolor, myattr, win1

	call initscr()
	call noecho()
	call cbreak()

*	refresh stdscr

	call refresh()

	if ( .not. has_colors() ) then
	
		call mvaddstr(10,20, 'Sorry, this demo is meant'//
&				' for color terminals')
		call refresh()
		call napms(1000)
		call endwin()
	endif


	myattr = pickcolor()

	call touchwin(stdscr)
	call wnoutrefresh(stdscr)
	
	win1 = newwin(10,50, LINES/2-5, COLS/2-25)
	call wbkgd( win1, myattr )
	call wborder( win1, 0,0,0,0,0,0,0,0 )
	
	call mvwaddstr(win1, 5, 10, 'I Like Your Choice of Colors')

	call wrefresh(win1)
	call napms(1000)

	call endwin()

	end
