* an example of checking whether or not a terminal has color capabilities
* and making use of them

	implicit none
	
	include '../../curses.fh'

	integer*4 ch
	
	call initscr()
	call noecho()
	call raw()

	call box(stdscr, ACS_VLINE, ACS_HLINE)

	if ( has_colors() ) then

		call start_color()
		call init_pair( 1, COLOR_RED, COLOR_BLACK )
		call attron( B_OR( A_BOLD, COLOR_PAIR(1) ) )	
		call mvaddstr( 10, 30, 'It''s a Colorful World' )
		
	elseif ( .not. has_colors() ) then
	
		call attron(A_BOLD)
		call mvaddstr( 10, 30, 'It''s a Monochrome World' )

	endif

	call mvaddstr( 15, 20, '<Press any key to continue>' )

	call refresh()

	ch = sgetch()

	call endwin()
	
	end
